local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_Mailbox"

local defaults = {
}
local options = {
}
local db
local scanned = false

local function OnText(message)
	addon['OnText'](childName, message)
end
local character = UnitName("player")
local realm = GetRealmName()
local faction,_ = UnitFactionGroup('player')

local function mailupdate()
-- print(db[faction][realm][character]['mail'],GetInboxNumItems() == 0)
--print(scanned)
	if(not scanned) then
		return db[faction][realm][character]['mailunread'],db[faction][realm][character]['mail']
	else
--		print(GetInboxNumItems())
		local cur,tot = GetInboxNumItems()
		db[faction][realm][character]['mail'] = tot
		return db[faction][realm][character]['mailunread'], tot
	end
end

local function mail()
	local packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead, wasReturned, textCreated, canReply, isGM
	local index,newunread = 0,0
	local unread, tot = mailupdate()
--	print("+",unread, tot)
	subject = "start"
	while(subject) do
		index = index + 1
		packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead, wasReturned, textCreated, canReply, isGM = GetInboxHeaderInfo(index)
		if(subject and not wasRead) then
			newunread = newunread + 1
			if(GetInboxNumItems() == 0 and scanned) then
				newunread = 0
			end
		end
	end
	if(not(db[faction][realm][character]['mail'] > 0 and GetInboxNumItems() == 0)) then
		db[faction][realm][character]['mailunread'] = newunread
	end
--	db[faction][realm][character]['mailunread'] = unread
--	print("-",unread, tot, newunread,not(db[faction][realm][character]['mail'] > 0 and GetInboxNumItems() == 0),db[faction][realm][character]['mailunread'])
	if(db[faction][realm][character]['newmail']) then
		if(HasNewMail() and tot == 0)  then
			tot = #{GetLatestThreeSenders()}
--			print(scanned, select(2,GetInboxNumItems()))
			if(scanned and select(2,GetInboxNumItems()) == 0) then
				tot = 0
			end
		end
		if(db[faction][realm][character]['mailunread'] == 0) then
			db[faction][realm][character]['mailunread'] = 1
		end
		if(tot == 0) then
			return tot
		else
			return (db[faction][realm][character]['mailunread'] .. "/" .. tot)
		end
	else
		return tot
	end
end

local function iterateMail()
	for i = 1, GetInboxNumItems() do
		if(not select(9,GetInboxHeaderInfo(i))) then
			return 1
		end
	end
	return nil
end

local function updateText(self, event)
--	print(mail())
	db[faction][realm][character]['newmail'] = HasNewMail()
--	print(event,MailFrame:IsVisible(),select(2,GetInboxNumItems()))
	if(MailFrame:IsVisible() and GetInboxNumItems() > 0) then
		db[faction][realm][character]['newmail'] = iterateMail()
	end
	OnText(addon['colorize'](mail(),db[faction][realm][character]['newmail'] and "00ff00" or "ffffff"))
	if(event == "MAIL_SHOW") then
		scanned = true
	elseif(event == "UPDATE_PENDING_MAIL") then
		scanned = false
	end
end
local function OnTooltip(tip)
	local zztip = type(tip.AddHeader) == 'function' and tip:AddHeader(childName) or tip:AddLine(childName)
	local senderlist = {GetLatestThreeSenders()}
	for _,v in ipairs(senderlist) do
		tip:AddLine(addon['colorize'](v,"ffffff"))
	end
	updateText()
end

local function init()
--	print("init",childName)
	addon['RegisterFunc']({'MAIL_SHOW',"MAIL_INBOX_UPDATE","UPDATE_PENDING_MAIL"},"OnEvent", updateText)
	options = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['type'] = "data source",
		['OnTooltipShow'] = OnTooltip,
	})
	db = addon['db']['profile'][childName]

	db[faction] = db[faction] or {}
	db[faction][realm] = db[faction][realm] or {}
	db[faction][realm][character] = db[faction][realm][character] or {}
	db[faction][realm][character]['mail'] = db[faction][realm][character]['mail'] or 0
	db[faction][realm][character]['mailunread'] = db[faction][realm][character]['mailunread'] or 0
end

addon['startup'](addon, name, childName, init, true, defaults)
